import pygame
import cgi
import urllib
import urllib2
import simplejson as json
import zbrowse as webbrowser
import logging
import socket
import sys
from optparse import OptionParser
import BaseHTTPServer
import zurl

class Service:
    code = None

    #client OAuth keys
    key    = '196410490403486'
    secret = 'f92c5fc6c24a4e499ebb9776c7879d9d'
    
    #facebook URIs and callbacks
    callback_url           = "http://auth.zaptronic.com/zaploc/auth.html"
    authorization_endpoint = "https://www.facebook.com/dialog/oauth"
    access_token_endpoint  = "https://graph.facebook.com/oauth/access_token"

    def is_authorized(self):    
        #get query string parameters
        try:
            f = open("/opt/zaploc/facebook.dat")
            if f:
                self.the_token = f.read()
            f.close();
        except:
            return False
        
        if self.the_token != None:            
            return True
        
        return False            
    
    def authorize(self):                        
        host_name = 'localhost'
        port_numbers = [8080, 8090]
        if True:
          server_class = BaseHTTPServer.HTTPServer
          zurl.RedirectHandler.service = "Facebook"
          try:
            port_number = port_numbers[0]
            httpd = server_class((host_name, port_number), zurl.RedirectHandler)
          except socket.error:
            port_number = port_numbers[1]
            try:
              httpd = server_class((host_name, port_number), zurl.RedirectHandler)
            except socket.error:
              options.localhost = False
    
        #construct Facebook authorization URI
        auth_url = self.authorization_endpoint + "?redirect_uri=" + self.callback_url + "&client_id=" + self.key + "&response_type=token&scope=publish_checkins,offline_access,publish_stream"
        #redirect the user to the Facebook authorization URI
        webbrowser.open(auth_url)
              
        httpd.handle_request()
        if 'error' in httpd.query_params:
            sys.exit('Authentication request was rejected.')

        if 'access_token' in httpd.query_params:
            self.the_token = httpd.query_params['access_token']
 
        f = open("/opt/zaploc/facebook.dat", "w")
        f.write(self.the_token)
        f.close()

    def list_spots(self, my_pos, radius):
        """ Get a list of 'spots' near the geo-center"""
        #build headers for protected data request
        headers = { 'Accept': 'application/json' }

        radius = 50000
        
        #make OAuth signed request for protected user profile
        # profile_url = "https://api.gowalla.com/users/me?oauth_token=" + token['access_token']
        list_url = "https://graph.facebook.com/search?type=place&center=%g,%g&distance=%g&access_token=" % ( my_pos[0], my_pos[1], radius)
        list_url += self.the_token
        
        request  = urllib2.Request(list_url, None, headers)
        response = urllib2.urlopen(request)
        
        data = json.load(response)       
        places = data["data"]        

        result = []    

        
        for p in places:
            result.append((
                p["id"],
                p["location"]["latitude"],
                p["location"]["longitude"],
                p["name"],
                "gfx/fbplace.png",
                1.0
            ))
        
        return result

    def list_friends(self, my_pos):
        return None

    def get_description(self, spot):
        """ Get Spot Info (not much, but... ) """
        #build headers for protected data request
        headers = { 'Accept': 'application/json' }

        radius = 50000
        
        #make OAuth signed request for protected user profile
        # profile_url = "https://api.gowalla.com/users/me?oauth_token=" + token['access_token']
        list_url = "https://graph.facebook.com/%s?access_token=" % ( spot[0] )
        list_url += self.the_token
        
        request  = urllib2.Request(list_url, None, headers)
        response = urllib2.urlopen(request)
        
        data = json.load(response)       

        result = ""
        link   = ""

        # print data
        
        try:
            link = data["link"]
        except:
            pass
        
        try:
            result += "Address:\n" + data["location"]["street"] + "\n"
            if "zip" in data["location"]:
                result += data["location"]["zip"] + " "
            result += data["location"]["city"] + "\n\n"
        except:
            pass        
        
        try:
            result += "Category: " + data["category"] + "\n"
        except:
            pass        
                
        return ( result, link )
    
    def check_in(self, spot, my_pos, text, twitter, facebook):
        """ Check in to a spot """
        #build headers for protected data request
        headers = { 'Accept': 'application/json' }

        # Make URL-safe
        checkin_url = 'https://graph.facebook.com/me/checkins'

        lat = "%g" % my_pos[0]
        lng = "%g" % my_pos[1]

        coords = '{ "latitude":"%g", "longitude":"%g" }' % ( my_pos[0], my_pos[1] )
        
        postvals = { 
            'place'        : spot[0], 
            'coordinates'  : coords, # { "latitude": lat, "longitude" : lng }, 
            'message'      : text, 
            'access_token' : self.the_token }

        try:
            params = urllib.urlencode(postvals)

            # print params
            
            request  = urllib2.Request(checkin_url, params, headers)
            f = urllib2.urlopen(request)
                            
            result = json.load(f)

            # print result

            return [ "Checked in to " + spot[3] + " on Facebook" ]
                            
        except:
            return None
        
    def name(self):
        return "Facebook Places"
    
    def cfgname(self):
        return "facebook"
    
    def onimg(self):
        return "gfx/plon.png"
    
    def offimg(self):
        return "gfx/ploff.png"    
    
    def tweetable(self):
        return False
        
    def facebookable(self):
        return False
    