import cgi
import urllib
import urllib2
import simplejson as json
import zbrowse as webbrowser
import BaseHTTPServer
import logging
import socket
import sys
import zurl

class Service:
    code = None

    #client OAuth keys
    key    = '14W5HFU300XTKJ4I1LDFBCBEOQRTZDPI15ZQV2HHKWPSA03B'
    secret = 'W2YKWMEBLK144TLYEYEYKZBTX0JDQ2NVWV1YF3WRBFYLAMEH'
    
    #gowalla URIs and callbacks
    callback_url           = "http://localhost:8080"
    authorization_endpoint = "https://foursquare.com/oauth2/authorize"
    access_token_endpoint  = "https://foursquare.com/oauth2/access_token"

    def is_authorized(self):    
        #get query string parameters
        params = cgi.FieldStorage()
           
        try:
            f = open("/opt/zaploc/foursquare.dat")
            if f:
                self.the_token = f.read()
            f.close();
        except:
            return False
        
        if self.the_token != None:            
            return True
        
        return False            
    
    def authorize(self):                        
        host_name = 'localhost'
        port_numbers = [8080, 8090]
        if True:
          server_class = BaseHTTPServer.HTTPServer
          zurl.RedirectHandler.service = "Foursquare"
          try:
            port_number = port_numbers[0]
            httpd = server_class((host_name, port_number), zurl.RedirectHandler)
          except socket.error:
            port_number = port_numbers[1]
            try:
              httpd = server_class((host_name, port_number), zurl.RedirectHandler)
            except socket.error:
              options.localhost = False
    
        #construct Foursquare authorization URI
        auth_url = self.authorization_endpoint + "?redirect_uri=" + self.callback_url + "&client_id=" + self.key + "&response_type=code"        
        #redirect the user to the Foursquare authorization URI
        webbrowser.open(auth_url)
              
        if True:
          httpd.handle_request()
          if 'error' in httpd.query_params:
            sys.exit('Authentication request was rejected.')
          if 'code' in httpd.query_params:
            code = httpd.query_params['code']

            #construct POST object for access token fetch request
            postvals = {'grant_type': 'authorization_code', 'client_id': self.key, 'client_secret': self.secret, 'code': code, 'redirect_uri': self.callback_url}
            
            #make request to capture access token
            params = urllib.urlencode(postvals)
            f = urllib.urlopen(self.access_token_endpoint, params)
            token = json.load(f)

            if "error" in token:
                return False

            self.the_token = token["access_token"]
            
            f = open("/opt/zaploc/foursquare.dat", "w")
            f.write(self.the_token)
            f.close()


    def list_spots(self, my_pos, radius):
        """ Get a list of 'spots' near the geo-center"""
        #build headers for protected data request
        headers = { 'Accept': 'application/json' }

        list_url = "https://api.foursquare.com/v2/venues/search?ll=%g,%g&intent=checkin&limit=45&oauth_token=" % my_pos[0:2]
        list_url += self.the_token
        request  = urllib2.Request(list_url, None, headers)
        response = urllib2.urlopen(request)
        response = json.load(response)

        # print response
        
        result = []
        
        try:
            groups = response["response"]["groups"]            

            for group in groups:                   
                spots = group["items"]                                    
                for spot in spots:
                    # print "  ------------ Spot ----------- "
                    # print spot

                    img = None
                    
                    for x in spot["categories"]:
                        if "icon" in x:
                            img = zurl.load_url_image(x["icon"],2.0)
                            break                                                   
                        
                    if img == None:
                        img = ( "gfx/unknown.png", 1.0 )
                        
                    result.append((
                        spot["id"],
                        spot["location"]["lat"],
                        spot["location"]["lng"],
                        spot["name"],
                        img[0],
                        img[1],
                    ))
            
        except:
            pass
            
        return result

    def list_friends(self, my_pos):
        return None

    def get_description(self, spot):
        """ Get the spot description """
        #build headers for protected data request
        headers = { 'Accept': 'application/json' }

        list_url = "https://api.foursquare.com/v2/venues/%s?oauth_token=" % spot[0]
        list_url += self.the_token
        # print list_url
        request  = urllib2.Request(list_url, None, headers)
        response = urllib2.urlopen(request)
        response = json.load(response)

        # print response["response"]
        # print response["response"]["venue"]["location"]["address"]        
        
        result = ""
        link   = ""               

        try:
            link = response["response"]["venue"]["shortUrl"]
        except:
            pass
        
        try:
            result += response["response"]["venue"]["location"]["address"]
            result += "\n" + response["response"]["venue"]["location"]["postalCode"] + " " + response["response"]["venue"]["location"]["city"] + "\n"
        except:
            pass

        try:
            result += "\nTwitter: %s" % response["response"]["venue"]["contact"]["twitter"]
        except:
            pass

            
        return ( result, link )
    
    def check_in(self, spot, my_pos, text, twitter, facebook):        

        """ Check in to a spot """
        #build headers for protected data request
        headers = { 'Accept': 'application/json' }

        # Make URL-safe
        checkin_url = 'https://api.foursquare.com/v2/checkins/add'

        broadcast = "public"
        if twitter:
            broadcast += ",twitter"
        if facebook:
            broadcast += ",facebook"
                
        postvals = { 
            'venueId': spot[0], 
            'll': ("%g,%g" % ( my_pos[0], my_pos[1])) , 
            'shout': text, 
            'broadcast': broadcast, 
            'oauth_token' : self.the_token}

        try:
            params = urllib.urlencode(postvals)
            request  = urllib2.Request(checkin_url, params, headers)
            f = urllib2.urlopen(request)
                            
            result = json.load(f)

            try:
                notes = result["notifications"]
                
                ret = [ "Checked in on Foursquare" ]
                
                for note in notes:
                    if "message" in note["item"]:
                        ret.append(note["item"]["message"])
                
                return ret            
            
            except:            
                return ["Checked In to " + spot[3] + " on Foursquare"]
                
        except:
            return None
        
    def name(self):
        return "Foursquare"
    
    def cfgname(self):
        return "foursquare"
    
    def onimg(self):
        return "gfx/fson.png"
    
    def offimg(self):
        return "gfx/fsoff.png"    
                
    def tweetable(self):
        return True
        
    def facebookable(self):
        return True
    